//
// XMM Science Analysis System
//
// Giuseppe Vacanti (cosine science & computing) 
// November 2001
//
// $Id: teststringutilioexceptions.cc,v 1.3 2003/02/20 10:07:56 jbakker Exp $
#include<iostream>
#include<stringutil.h>
#include<string>

int main() {

  std::string str("abc");
  std::string number("1234.5");

  bool fail = true;
  try {
    int x = toNumber<int>(str);
    std::cout << "string (" << str << ") to int -> " << x << std::endl;
  }
  catch(std::string e) {
    std::cout << "caught bad string to int conversion" << std::endl;
    std::cout << "*** " << e << std::endl;
    fail = false;
  }

  if(fail)
    std::cerr << "try-catch block failed" << std::endl;

  try {
    int x = toNumber<int>(number);
    std::cout << "number (" << number << ") to int -> " << x << std::endl;
  }
  catch(...) {
    std::cout << "float to int conversion failed" << std::endl;
    exit(1);
  }

  try {
    double x = toNumber<double>(number);
    std::cout << "number (" << number << ") to double -> " << x << std::endl;
  }
  catch(...) {
    std::cout << "float to double conversion failed" << std::endl;
    exit(1);
  }

  if(fail)
    exit(1);

}  
    
    
